'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _debounce = require('lodash/debounce');

var _debounce2 = _interopRequireDefault(_debounce);

var _range = require('lodash/range');

var _range2 = _interopRequireDefault(_range);

var _utils = require('./utils');

var _locale = require('./locale');

var _locale2 = _interopRequireDefault(_locale);

var _theme = require('./theme');

var _theme2 = _interopRequireDefault(_theme);

var _Today = require('./Today');

var _Today2 = _interopRequireDefault(_Today);

var _Header = require('./Header');

var _Header2 = _interopRequireDefault(_Header);

var _MonthList = require('./MonthList');

var _MonthList2 = _interopRequireDefault(_MonthList);

var _Weekdays = require('./Weekdays');

var _Weekdays2 = _interopRequireDefault(_Weekdays);

var _Years = require('./Years');

var _Years2 = _interopRequireDefault(_Years);

var _parse = require('date-fns/parse');

var _parse2 = _interopRequireDefault(_parse);

var _format = require('date-fns/format');

var _format2 = _interopRequireDefault(_format);

var _add_days = require('date-fns/add_days');

var _add_days2 = _interopRequireDefault(_add_days);

var _is_same_day = require('date-fns/is_same_day');

var _is_same_day2 = _interopRequireDefault(_is_same_day);

var _is_before = require('date-fns/is_before');

var _is_before2 = _interopRequireDefault(_is_before);

var _is_after = require('date-fns/is_after');

var _is_after2 = _interopRequireDefault(_is_after);

var _get_day = require('date-fns/get_day');

var _get_day2 = _interopRequireDefault(_get_day);

var _start_of_month = require('date-fns/start_of_month');

var _start_of_month2 = _interopRequireDefault(_start_of_month);

var _start_of_day = require('date-fns/start_of_day');

var _start_of_day2 = _interopRequireDefault(_start_of_day);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = {
	container: {
		'root': 'Cal__Container__root',
		'landscape': 'Cal__Container__landscape',
		'wrapper': 'Cal__Container__wrapper',
		'listWrapper': 'Cal__Container__listWrapper'
	},
	day: {
		'root': 'Cal__Day__root',
		'enabled': 'Cal__Day__enabled',
		'highlighted': 'Cal__Day__highlighted',
		'today': 'Cal__Day__today',
		'disabled': 'Cal__Day__disabled',
		'selected': 'Cal__Day__selected',
		'month': 'Cal__Day__month',
		'year': 'Cal__Day__year',
		'selection': 'Cal__Day__selection',
		'day': 'Cal__Day__day'
	}
};

var InfiniteCalendar = (_temp = _class = function (_Component) {
	_inherits(InfiniteCalendar, _Component);

	function InfiniteCalendar(props) {
		_classCallCheck(this, InfiniteCalendar);

		// Initialize
		var _this = _possibleConstructorReturn(this, _Component.call(this));

		_this.onDaySelect = function (selectedDate, e) {
			var shouldHeaderAnimate = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : _this.props.shouldHeaderAnimate;
			var _this$props = _this.props,
			    shouldPreventSelect = _this$props.shouldPreventSelect,
			    onSelect = _this$props.onSelect;


			if (!shouldPreventSelect(selectedDate)) {
				onSelect(selectedDate, e);

				_this.setState({
					selectedDate: selectedDate,
					shouldHeaderAnimate: shouldHeaderAnimate,
					highlightedDate: new Date(selectedDate)
				}, function () {
					_this.clearHighlight();
				});
			}
		};

		_this.getCurrentOffset = function () {
			return _this.scrollTop;
		};

		_this.getDateOffset = function (date) {
			return _this._MonthList && _this._MonthList.getDateOffset(date);
		};

		_this.scrollTo = function (offset) {
			return _this._MonthList && _this._MonthList.scrollTo(offset);
		};

		_this.scrollToDate = function () {
			var date = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : new Date();
			var offset = arguments[1];

			return _this._MonthList && _this._MonthList.scrollToDate(date, offset);
		};

		_this.getScrollSpeed = (0, _utils.getScrollSpeed)();

		_this.onScroll = function (_ref) {
			var scrollTop = _ref.scrollTop;
			var _this$props2 = _this.props,
			    onScroll = _this$props2.onScroll,
			    showOverlay = _this$props2.showOverlay,
			    showTodayHelper = _this$props2.showTodayHelper;
			var isScrolling = _this.state.isScrolling;

			var scrollSpeed = _this.scrollSpeed = Math.abs(_this.getScrollSpeed(scrollTop));
			_this.scrollTop = scrollTop;

			// We only want to display the months overlay if the user is rapidly scrolling
			if (showOverlay && scrollSpeed >= 50 && !isScrolling) {
				_this.setState({
					isScrolling: true
				});
			}

			if (showTodayHelper) {
				_this.updateTodayHelperPosition(scrollSpeed);
			}

			onScroll(scrollTop);
			_this.onScrollEnd();
		};

		_this.onScrollEnd = (0, _debounce2.default)(function () {
			var _this$props3 = _this.props,
			    onScrollEnd = _this$props3.onScrollEnd,
			    showTodayHelper = _this$props3.showTodayHelper;
			var isScrolling = _this.state.isScrolling;


			if (isScrolling) {
				_this.setState({ isScrolling: false });
			}

			if (showTodayHelper) {
				_this.updateTodayHelperPosition(0);
			}

			onScrollEnd(_this.scrollTop);
		}, 150);

		_this.updateTodayHelperPosition = function (scrollSpeed) {
			var today = _this.today;
			var scrollTop = _this.scrollTop;
			var showToday = _this.state.showToday;
			var _this$props4 = _this.props,
			    height = _this$props4.height,
			    rowHeight = _this$props4.rowHeight,
			    todayHelperRowOffset = _this$props4.todayHelperRowOffset;

			var newState = void 0;
			if (!_this._todayOffset) {
				_this._todayOffset = _this.getDateOffset(today) + // scrollTop offset of the month "today" is in
				Math.ceil((today.getDate() - 7 + (0, _get_day2.default)((0, _start_of_month2.default)(today))) / 7) * rowHeight // offset of "today" within its month
				;
			}

			if (scrollTop >= _this._todayOffset + rowHeight * (todayHelperRowOffset + 1)) {
				if (showToday !== 1) newState = 1; //today is above the fold
			} else if (scrollTop + height <= _this._todayOffset + rowHeight - rowHeight * (todayHelperRowOffset + 1)) {
				if (showToday !== -1) newState = -1; //today is below the fold
			} else if (showToday && scrollSpeed <= 1) {
				newState = false;
			}

			if (scrollTop === 0) {
				newState = false;
			}

			if (newState != null) {
				_this.setState({ showToday: newState });
			}
		};

		_this.handleKeyDown = function (e) {
			var _this$props5 = _this.props,
			    maxDate = _this$props5.maxDate,
			    minDate = _this$props5.minDate,
			    onKeyDown = _this$props5.onKeyDown;
			var _this$state = _this.state,
			    display = _this$state.display,
			    selectedDate = _this$state.selectedDate,
			    highlightedDate = _this$state.highlightedDate,
			    showToday = _this$state.showToday;

			var delta = 0;

			onKeyDown(e);

			if ([_utils.keyCodes.left, _utils.keyCodes.up, _utils.keyCodes.right, _utils.keyCodes.down].indexOf(e.keyCode) > -1 && typeof e.preventDefault === 'function') {
				e.preventDefault();
			}

			if (!selectedDate) {
				selectedDate = new Date();
			}

			if (display === 'days') {
				if (!highlightedDate) {
					highlightedDate = new Date(selectedDate);
					_this.setState({ highlightedDate: highlightedDate });
				}

				switch (e.keyCode) {
					case _utils.keyCodes.enter:
						_this.onDaySelect(new Date(highlightedDate), e);
						return;
					case _utils.keyCodes.left:
						delta = -1;
						break;
					case _utils.keyCodes.right:
						delta = +1;
						break;
					case _utils.keyCodes.down:
						delta = +7;
						break;
					case _utils.keyCodes.up:
						delta = -7;
						break;
					default:
						delta = 0;
				}

				if (delta) {
					var rowHeight = _this.props.rowHeight;

					var newHighlightedDate = (0, _add_days2.default)(highlightedDate, delta);

					// Make sure the new highlighted date isn't before min / max
					if ((0, _is_before2.default)(newHighlightedDate, minDate)) {
						newHighlightedDate = new Date(minDate);
					} else if ((0, _is_after2.default)(newHighlightedDate, maxDate)) {
						newHighlightedDate = new Date(maxDate);
					}

					// Update the highlight indicator
					_this.clearHighlight();

					// Scroll the view
					if (!_this.currentOffset) _this.currentOffset = _this.getCurrentOffset();
					var currentOffset = _this.currentOffset;
					var monthOffset = _this.getDateOffset(newHighlightedDate);
					var navOffset = showToday ? 36 : 0;

					var highlightedEl = _this.highlightedEl = _this.node.querySelector('[data-date=\'' + (0, _format2.default)(newHighlightedDate, 'YYYY-MM-DD') + '\']');

					// Edge-case: if the user tries to use the keyboard when the new highlighted date isn't rendered because it's too far off-screen
					// We need to scroll to the month of the new highlighted date so it renders
					if (!highlightedEl) {
						_this.scrollTo(monthOffset - navOffset);
						return;
					}

					highlightedEl.classList.add(styles.day.highlighted);

					var dateOffset = highlightedEl.offsetTop - rowHeight;
					var newOffset = monthOffset + dateOffset;

					if (currentOffset !== newOffset) {
						_this.currentOffset = newOffset;
						_this.scrollTo(newOffset - navOffset);
					}

					// Update the reference to the currently highlighted date
					_this.setState({
						highlightedDate: newHighlightedDate
					});
				}
			} else if (display === 'years' && _this._Years) {
				_this._Years.handleKeyDown(e);
			}
		};

		_this.setDisplay = function (display) {
			_this.setState({ display: display });
		};

		_this.updateYears(props);
		_this.state = {
			selectedDate: _this.parseSelectedDate(props.selectedDate),
			display: props.display,
			shouldHeaderAnimate: props.shouldHeaderAnimate
		};
		return _this;
	}

	InfiniteCalendar.prototype.componentDidMount = function componentDidMount() {
		var _props = this.props,
		    autoFocus = _props.autoFocus,
		    keyboardSupport = _props.keyboardSupport;


		if (keyboardSupport && autoFocus) {
			this.node.focus();
		}
	};

	InfiniteCalendar.prototype.componentWillReceiveProps = function componentWillReceiveProps(next) {
		var _props2 = this.props,
		    min = _props2.min,
		    minDate = _props2.minDate,
		    max = _props2.max,
		    maxDate = _props2.maxDate,
		    selectedDate = _props2.selectedDate;
		var display = this.state.display;


		if (next.min !== min || next.minDate !== minDate || next.max !== max || next.maxDate !== maxDate) {
			this.updateYears(next);
		}
		if (next.selectedDate !== selectedDate) {
			var parsed = this.parseSelectedDate(next.selectedDate);
			this.setState({
				selectedDate: parsed
			});
			if (parsed) this.scrollToDate(parsed, -this.props.rowHeight * 2);
		} else if (next.minDate !== minDate || next.maxDate !== maxDate) {
			// Need to make sure the currently selected date is not before the new minDate or after maxDate
			var _selectedDate = this.parseSelectedDate(this.state.selectedDate);
			if (!(0, _is_same_day2.default)(_selectedDate, this.state.selectedDate)) {
				this.setState({
					selectedDate: _selectedDate
				});
			}
		}
		if (next.display !== display) {
			this.setState({
				display: next.display
			});
		}
	};

	InfiniteCalendar.prototype.parseSelectedDate = function parseSelectedDate(selectedDate) {
		if (!selectedDate) {
			return null;
		}

		selectedDate = (0, _parse2.default)(selectedDate);

		// Selected Date should not be before min date or after max date
		if ((0, _is_before2.default)(selectedDate, this._minDate)) {
			return this._minDate;
		} else if ((0, _is_after2.default)(selectedDate, this._maxDate)) {
			return this._maxDate;
		}

		return (0, _start_of_day2.default)(new Date(selectedDate));
	};

	InfiniteCalendar.prototype.updateYears = function updateYears() {
		var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.props;

		this._min = (0, _parse2.default)(props.min);
		this._max = (0, _parse2.default)(props.max);
		this._minDate = (0, _parse2.default)(props.minDate);
		this._maxDate = (0, _parse2.default)(props.maxDate);

		var min = this._min.getFullYear();
		var max = this._max.getFullYear();

		var months = [];
		var year = void 0,
		    month = void 0;
		for (year = min; year <= max; year++) {
			for (month = 0; month < 12; month++) {
				months.push({ year: year, month: month });
			}
		}

		this.months = months;
	};

	InfiniteCalendar.prototype.getDisabledDates = function getDisabledDates(disabledDates) {
		return disabledDates && disabledDates.map(function (date) {
			return (0, _format2.default)((0, _parse2.default)(date), 'YYYY-MM-DD');
		});
	};

	InfiniteCalendar.prototype.getLocale = function getLocale() {
		var customLocale = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.props.locale;

		return Object.assign({}, _locale2.default, customLocale);
	};

	InfiniteCalendar.prototype.getTheme = function getTheme() {
		var customTheme = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.props.theme;

		return Object.assign({}, _theme2.default, customTheme);
	};

	InfiniteCalendar.prototype.clearHighlight = function clearHighlight() {
		if (this.highlightedEl) {
			this.highlightedEl.classList.remove(styles.day.highlighted);
			this.highlightedEl = null;
		}
	};

	InfiniteCalendar.prototype.render = function render() {
		var _classNames,
		    _this2 = this;

		var _props3 = this.props,
		    className = _props3.className,
		    disabledDays = _props3.disabledDays,
		    height = _props3.height,
		    hideYearsOnSelect = _props3.hideYearsOnSelect,
		    keyboardSupport = _props3.keyboardSupport,
		    layout = _props3.layout,
		    overscanMonthCount = _props3.overscanMonthCount,
		    minDate = _props3.minDate,
		    maxDate = _props3.maxDate,
		    showTodayHelper = _props3.showTodayHelper,
		    showHeader = _props3.showHeader,
		    tabIndex = _props3.tabIndex,
		    width = _props3.width,
		    other = _objectWithoutProperties(_props3, ['className', 'disabledDays', 'height', 'hideYearsOnSelect', 'keyboardSupport', 'layout', 'overscanMonthCount', 'minDate', 'maxDate', 'showTodayHelper', 'showHeader', 'tabIndex', 'width']);

		var disabledDates = this.getDisabledDates(this.props.disabledDates);
		var locale = this.getLocale();
		var theme = this.getTheme();
		var _state = this.state,
		    display = _state.display,
		    isScrolling = _state.isScrolling,
		    selectedDate = _state.selectedDate,
		    showToday = _state.showToday,
		    shouldHeaderAnimate = _state.shouldHeaderAnimate;

		var today = this.today = (0, _start_of_day2.default)(new Date());

		// Selected date should not be disabled
		if (selectedDate && (disabledDates && disabledDates.indexOf((0, _format2.default)(selectedDate, 'YYYY-MM-DD')) !== -1 || disabledDays && disabledDays.indexOf((0, _get_day2.default)(selectedDate)) !== -1)) {
			selectedDate = null;
		}

		return _react2.default.createElement(
			'div',
			{
				tabIndex: tabIndex,
				onKeyDown: keyboardSupport && this.handleKeyDown,
				className: (0, _classnames2.default)(className, styles.container.root, (_classNames = {}, _classNames[styles.container.landscape] = layout === 'landscape', _classNames)),
				style: { color: theme.textColor.default, width: width },
				'aria-label': 'Calendar',
				ref: function ref(node) {
					_this2.node = node;
				}
			},
			showHeader && _react2.default.createElement(_Header2.default, {
				selectedDate: selectedDate,
				shouldHeaderAnimate: shouldHeaderAnimate,
				layout: layout,
				theme: theme,
				locale: locale,
				scrollToDate: this.scrollToDate,
				setDisplay: this.setDisplay,
				display: display
			}),
			_react2.default.createElement(
				'div',
				{ className: styles.container.wrapper },
				_react2.default.createElement(_Weekdays2.default, { locale: locale, theme: theme }),
				_react2.default.createElement(
					'div',
					{ className: styles.container.listWrapper },
					showTodayHelper && _react2.default.createElement(_Today2.default, {
						scrollToDate: this.scrollToDate,
						show: showToday,
						today: today,
						theme: theme,
						locale: locale
					}),
					_react2.default.createElement(_MonthList2.default, _extends({
						ref: function ref(instance) {
							_this2._MonthList = instance;
						}
					}, other, {
						width: width,
						height: height,
						selectedDate: selectedDate,
						disabledDates: disabledDates,
						disabledDays: disabledDays,
						months: this.months,
						onDaySelect: this.onDaySelect,
						onScroll: this.onScroll,
						isScrolling: isScrolling,
						today: today,
						min: this._min,
						minDate: this._minDate,
						maxDate: this._maxDate,
						theme: theme,
						locale: locale,
						overscanMonthCount: overscanMonthCount
					}))
				),
				display === 'years' && _react2.default.createElement(_Years2.default, {
					ref: function ref(instance) {
						_this2._Years = instance;
					},
					width: width,
					height: height,
					onDaySelect: this.onDaySelect,
					minDate: minDate,
					maxDate: maxDate,
					selectedDate: selectedDate,
					theme: theme,
					today: today,
					years: (0, _range2.default)(this._min.getFullYear(), this._max.getFullYear() + 1),
					setDisplay: this.setDisplay,
					scrollToDate: this.scrollToDate,
					hideYearsOnSelect: hideYearsOnSelect
				})
			)
		);
	};

	return InfiniteCalendar;
}(_react.Component), _class.defaultProps = {
	width: 400,
	height: 500,
	rowHeight: 56,
	overscanMonthCount: 2,
	todayHelperRowOffset: 4,
	layout: 'portrait',
	display: 'days',
	selectedDate: new Date(),
	min: new Date(1980, 0, 1),
	minDate: new Date(1980, 0, 1),
	max: new Date(2050, 11, 31),
	maxDate: new Date(2050, 11, 31),
	keyboardSupport: true,
	autoFocus: true,
	shouldHeaderAnimate: true,
	showOverlay: true,
	showTodayHelper: true,
	showHeader: true,
	tabIndex: 1,
	locale: {},
	theme: {},
	hideYearsOnSelect: true,
	shouldPreventSelect: function shouldPreventSelect() {
		return false;
	},
	onSelect: _utils.emptyFn,
	onScroll: _utils.emptyFn,
	onScrollEnd: _utils.emptyFn,
	onKeyDown: _utils.emptyFn
}, _temp);
exports.default = InfiniteCalendar;
process.env.NODE_ENV !== "production" ? InfiniteCalendar.propTypes = {
	selectedDate: _react.PropTypes.instanceOf(Date),
	min: _react.PropTypes.instanceOf(Date),
	max: _react.PropTypes.instanceOf(Date),
	minDate: _react.PropTypes.instanceOf(Date),
	maxDate: _react.PropTypes.instanceOf(Date),
	locale: _react.PropTypes.object,
	theme: _react.PropTypes.object,
	width: _react.PropTypes.number,
	height: _react.PropTypes.number,
	rowHeight: _react.PropTypes.number,
	className: _react.PropTypes.string,
	overscanMonthCount: _react.PropTypes.number,
	todayHelperRowOffset: _react.PropTypes.number,
	disabledDays: _react.PropTypes.arrayOf(_react.PropTypes.number),
	disabledDates: _react.PropTypes.arrayOf(_react.PropTypes.instanceOf(Date)),
	shouldPreventSelect: _react.PropTypes.func,
	onSelect: _react.PropTypes.func,
	onScroll: _react.PropTypes.func,
	onScrollEnd: _react.PropTypes.func,
	keyboardSupport: _react.PropTypes.bool,
	autoFocus: _react.PropTypes.bool,
	onKeyDown: _react.PropTypes.func,
	tabIndex: _react.PropTypes.number,
	layout: _react.PropTypes.oneOf(['portrait', 'landscape']),
	display: _react.PropTypes.oneOf(['years', 'days']),
	hideYearsOnSelect: _react.PropTypes.bool,
	shouldHeaderAnimate: _react.PropTypes.bool,
	showOverlay: _react.PropTypes.bool,
	showTodayHelper: _react.PropTypes.bool,
	showHeader: _react.PropTypes.bool
} : void 0;
module.exports = exports['default'];